using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using Exferia_Aplicacion.General;
using Exferia_KairosPRO_EF;
using Exferia_KairosPRO._1_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_Aplicacion.Modelos_Informes;
using System.Data.SqlClient;
using System.Threading;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRSS_Fichajes_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        private List<INTERNO_KRSS_Fichajes_Listado_Modelo> g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO = null;

        public override List<dynamic> Obtener_Listado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<dynamic> lst_KRS = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta.................................................................
                ConsultaRellenar_Listado_Secundario(obj_KairosProEntities, _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //........................................................................

                if ((g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO != null) && (g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO.Count() > 0))
                {
                    lst_KRS = g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_Listado_Secundario), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return lst_KRS;
        }
        public override dynamic Obtener_RegistroListado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            KairosProEntities obj_KairosProEntities = null;
            dynamic dnm_KRS = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_Listado_Secundario(obj_KairosProEntities, _lst_CamposConRelacionABuscar, _lng_id, _lst_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...............................................................

                if ((g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO != null) && (g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO.Count() > 0))
                {
                    dnm_KRS = g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_RegistroListado_Secundario), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return dnm_KRS;
        }
        protected override void ConsultaRellenar_Listado_Secundario(KairosProEntities _obj_KairosProEntities, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                //Datos del Padre si los tuviera .........................
                long lng_idEmpleado_Kairos = -1;
                string str_Opcion_Empleado_Kairos = "";

                long lng_idEmpresa = -1;
                string str_Opcion_Empresa = "";

                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    foreach (INTERNO_Filtro_OpcionPadre_Modelo mdl_INTERNO_Filtro_OpcionPadre_Modelo in _lst_INTERNO_Filtro_OpcionPadre_Modelo)
                    {
                        //EMPLEADO
                        if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_KRS_EMPLEADOS))
                        {
                            str_Opcion_Empleado_Kairos = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                            lng_idEmpleado_Kairos = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                        }
                        //EMPRESA
                        else if (mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO.Equals(Variables.G_STR_OPCION_GEN_EMPRESA))
                        {
                            str_Opcion_Empresa = mdl_INTERNO_Filtro_OpcionPadre_Modelo.NOMBRE_CAMPO;
                            lng_idEmpresa = mdl_INTERNO_Filtro_OpcionPadre_Modelo.VALOR;
                        }
                    }
                }

                string str_SQL =
                    " SELECT " +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.id) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.id) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.idEmpleado) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpleado) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.idTerminal) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idTerminal) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.idDispositivoModelo) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idDispositivoModelo) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.codigoCliente) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.fechaHora) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.observaciones) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.observaciones) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.gps_Posicion_Latitud) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.gps_Posicion_Latitud) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.gps_Posicion_Longitud) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.gps_Posicion_Longitud) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.gps_FechaHora) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.gps_FechaHora) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.gps_Proveedor) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.gps_Proveedor) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.gps_Altitud) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.gps_Altitud) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.modificado) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.modificado) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.anulado) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.anulado) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.validado) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.validado) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.tipoDispositivo) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.tipoDispositivo) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.entradaSalida) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.entradaSalida) + "," +
                        nameof(INTERNO_KRSS_Fichajes_Listado_Modelo.idEmpresa) + " = " + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + 
                " FROM " + nameof(KRSS_Fichajes) +
                " WHERE " +
                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa and " +
                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente AND " +
                        (str_Opcion_Empleado_Kairos != "" ? (nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpleado) + "=@idEmpleado") : " 1 = 1 ");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpresa",  lng_idEmpresa),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                     new SqlParameter("@idEmpleado",  lng_idEmpleado_Kairos)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_KRSS_Fichajes_Listado_Modelo_SECUNDARIO = _obj_KairosProEntities.Database.SqlQuery<INTERNO_KRSS_Fichajes_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(ConsultaRellenar_Listado_Secundario), true);
            }
        }

        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(KairosProEntities _dbcontext, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region Obtener
        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;
        private static int g_int_TotalHilos_Obtener = 3;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                     " SELECT " +
                        nameof(KRSS_Fichajes.id) + " , " +
                        nameof(KRSS_Fichajes.idEmpleado) + " , " +
                        nameof(KRSS_Fichajes.codigoCliente) + " , " +
                        nameof(KRSS_Fichajes.fechaHora) + " , " +
                        nameof(KRSS_Fichajes.observaciones) + " , " +
                        nameof(KRSS_Fichajes.gps_Posicion_Latitud) + " , " +
                        nameof(KRSS_Fichajes.gps_Posicion_Longitud) + " , " +
                        nameof(KRSS_Fichajes.gps_FechaHora) + " , " +
                        nameof(KRSS_Fichajes.gps_Proveedor) + " , " +
                        nameof(KRSS_Fichajes.gps_Altitud) + " , " +
                        nameof(KRSS_Fichajes.idTerminal) + " , " +
                        nameof(KRSS_Fichajes.idDispositivoModelo) + " , " +
                        nameof(KRSS_Fichajes.modificado) + " , " +
                        nameof(KRSS_Fichajes.anulado) + " , " +
                        nameof(KRSS_Fichajes.validado) + " , " +
                        nameof(KRSS_Fichajes.tipoDispositivo) + " , " +
                        nameof(KRSS_Fichajes.entradaSalida) + " , " +
                        nameof(KRSS_Fichajes.idEmpresa) +
                    " FROM " + nameof(KRSS_Fichajes) +
                    " WHERE " +
                            nameof(KRSS_Fichajes.id) + "=@id and " +
                            nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_KairosProEntities.Database.SqlQuery<KRSS_Fichajes>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //KRS_Empleados ##########################################################################################
                    ThreadStart obj_ThreadStart_EMPLEADOS = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                    Thread obj_Thread_EMPLEADOS = new Thread(obj_ThreadStart_EMPLEADOS);
                    obj_Thread_EMPLEADOS.Start();

                    //KRS_Terminales ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idTerminal != null)
                    {
                        ThreadStart obj_ThreadStart_TERMINALES = new ThreadStart(Obtener_Terminales_Modelo_Obtener);
                        Thread obj_Thread_TERMINALES = new Thread(obj_ThreadStart_TERMINALES);
                        obj_Thread_TERMINALES.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //KRSS_DispositivosModelo ##########################################################################################
                    ThreadStart obj_ThreadStart_DISPOSITIVOMODELO = new ThreadStart(Obtener_DispositivoModelo_Modelo_Obtener);
                    Thread obj_Thread_DISPOSITIVOMODELO = new Thread(obj_ThreadStart_DISPOSITIVOMODELO);
                    obj_Thread_DISPOSITIVOMODELO.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }


            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                KRS_Empleados_Datos obj_KRS_Empleados_Datos = new KRS_Empleados_Datos();
                g_dnm_Modelo_Obtener.KRS_Empleados = obj_KRS_Empleados_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idEmpleado, g_dnm_Modelo_Obtener.codigoCliente, false,false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }

        private void Obtener_Terminales_Modelo_Obtener()
        {
            try
            {
                KRS_Terminales_Datos obj_KRS_Terminales_Datos = new KRS_Terminales_Datos();
                g_dnm_Modelo_Obtener.KRS_Terminales = obj_KRS_Terminales_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idTerminal, g_dnm_Modelo_Obtener.codigoCliente);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }

        private void Obtener_DispositivoModelo_Modelo_Obtener()
        {
            try
            {
                KRSS_DispositivosModelo_Datos obj_KRSS_DispositivosModelo_Datos = new KRSS_DispositivosModelo_Datos();
                g_dnm_Modelo_Obtener.KRSS_DispositivosModelo = obj_KRSS_DispositivosModelo_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idDispositivoModelo, g_dnm_Modelo_Obtener.codigoCliente);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }

        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_CampoBusqueda, string _str_Filtro)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region Procedimientos para VerificacionFichajes ServicioWindows
        public List<INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo> Obtener_Listado_ParaVerificacionFichajes(long _lng_CodigoCliente, long _lng_idEmpleado, DateTime _dtt_FechaDesde, DateTime _dtt_FechaHasta, long _lng_idEmpresa)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo> lst_INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                       " SELECT " +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.id) + "=" + nameof(KRSS_Fichajes.id) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.idEmpleado) + "=" + nameof(KRSS_Fichajes.idEmpleado) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.codigoCliente) + "=" + nameof(KRSS_Fichajes.codigoCliente) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.fechaHora) + "=" + nameof(KRSS_Fichajes.fechaHora) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.observaciones) + "=" + nameof(KRSS_Fichajes.observaciones) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.gps_Posicion_Latitud) + "=" + nameof(KRSS_Fichajes.gps_Posicion_Latitud) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.gps_Posicion_Longitud) + "=" + nameof(KRSS_Fichajes.gps_Posicion_Longitud) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.gps_FechaHora) + "=" + nameof(KRSS_Fichajes.gps_FechaHora) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.gps_Proveedor) + "=" + nameof(KRSS_Fichajes.gps_Proveedor) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.gps_Altitud) + "=" + nameof(KRSS_Fichajes.gps_Altitud) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.idTerminal) + "=" + nameof(KRSS_Fichajes.idTerminal) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.idDispositivoModelo) + "=" + nameof(KRSS_Fichajes.idDispositivoModelo) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.validado) + "=" + nameof(KRSS_Fichajes.validado) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.entradaSalida) + "=" + nameof(KRSS_Fichajes.entradaSalida) + "," +
                                nameof(INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo.idEmpresa) + "=" + nameof(KRSS_Fichajes.idEmpresa) +
                       " FROM " + nameof(KRSS_Fichajes) +
                       " WHERE " +
                                    nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpleado) + "=@idEmpleado and " +
                                    nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa and " +
                                    nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente and " +
                                    nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + ">=@fechaDesde and " +
                                    nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + "<=@fechaHasta and " +
                                    nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.anulado) + " IS null  ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@idEmpresa",  _lng_idEmpresa),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente),
                     new SqlParameter("@fechaDesde",  _dtt_FechaDesde),
                     new SqlParameter("@fechaHasta",  _dtt_FechaHasta)
                };

                //Rellenar el Modelo
                lst_INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo = obj_KairosProEntities.Database.SqlQuery<INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_Listado_ParaVerificacionFichajes), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return lst_INTERNO_VerificacionFichajes_KRSS_Fichajes_Modelo;
        }

        public List<INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo> Obtener_Listado_Fichajes_Dispositivos(long _lng_CodigoCliente, DateTime _dtt_FechaDesde, DateTime _dtt_FechaHasta, long _lng_idEmpresa)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo> lst_INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                            " SELECT " +
                                    nameof(INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo.marca) + "=" + nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.marca) + " , " +
                                    nameof(INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo.modelo) + "=" + nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.modelo) + " , " +
                                    nameof(INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo.mac) + "=" + nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.mac) + " , " +
                                    nameof(INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo.fabricante) + "=" + nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.fabricante) + " , " +
                                    nameof(INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo.total) + "= COUNT(*), " +
                                    nameof(INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo.terminal_Empleado_Descripcion) + "= '' " +
                            " FROM " + nameof(KRSS_Fichajes) +
                            " LEFT JOIN " + nameof(KRSS_DispositivosModelo) + " on " + nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.id) + "=" + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idDispositivoModelo) + " and " +
                                                                                       nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.codigoCliente) + "=" + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) +
                            " LEFT JOIN " + nameof(KRS_Terminales) + " on " + nameof(KRS_Terminales) + "." + nameof(KRS_Terminales.id) + "=" + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idTerminal) + " and " +
                                                                              nameof(KRS_Terminales) + "." + nameof(KRS_Terminales.codigoCliente) + "=" + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) +
                            " LEFT JOIN " + nameof(KRS_Empleados) + " on " + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.id) + "=" + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpleado) + " and " +
                                                                             nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.codigoCliente) + "=" + nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) +
                            " WHERE " +
                                nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente AND " +
                                nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa AND " +
                                nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + ">=@Fechadesde AND " +
                                nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + "<=@FechaHasta " +
                            " GROUP BY " +
                                nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.fabricante) + ", " +
                                nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.marca) + ", " +
                                nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.modelo) + ", " +
                                nameof(KRSS_DispositivosModelo) + "." + nameof(KRSS_DispositivosModelo.mac);

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente),
                     new SqlParameter("@idEmpresa",  _lng_idEmpresa),
                     new SqlParameter("@Fechadesde",  _dtt_FechaDesde),
                     new SqlParameter("@FechaHasta",  _dtt_FechaHasta)
                };

                //Rellenar el Modelo
                lst_INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo = obj_KairosProEntities.Database.SqlQuery<INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_Listado_Fichajes_Dispositivos));
            }

            return lst_INTERNO_KairosPRO_Fichaje_PorFechas_TotalDispositivos_Modelo;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRSS_Fichajes g_mdl_KRSS_Fichajes = null;
        public KRSS_Fichajes Obtener_Modelo_Por_Id(long _lng_id, 
                                                    long _lng_CodigoCliente,
                                                    bool _bol_Cargar_DispositivoModelo,
                                                    bool _bol_Cargar_FichajesFotos)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.id) + "=@id and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_DispositivoModelo,
                                         _bol_Cargar_FichajesFotos);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRSS_Fichajes;
        }

        #region Ejercutar Consulta Modelo
        private static int g_int_TotalHilos_Modelo = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros,
                                              bool _bol_Cargar_DispositivoModelo,
                                              bool _bol_Cargar_FichajesFotos)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_KRSS_Fichajes = obj_KairosProEntities.Database.SqlQuery<KRSS_Fichajes>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_mdl_KRSS_Fichajes != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                    }

                    //KRSS_DispositivosModelo ##########################################################################################
                    if (_bol_Cargar_DispositivoModelo)
                    {
                        ThreadStart obj_ThreadStart_DISPOSITIVOMODELO = new ThreadStart(Obtener_DispositivosModelo_Modelo);
                        Thread obj_Thread_DISPOSITIVOMODELO = new Thread(obj_ThreadStart_DISPOSITIVOMODELO);
                        obj_Thread_DISPOSITIVOMODELO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo[0] = true;
                    }

                    //KRSS_FichajesFotos ##########################################################################################
                    if (_bol_Cargar_FichajesFotos)
                    {
                        ThreadStart obj_ThreadStart_FICHAJESFOTOS = new ThreadStart(Obtener_FichajesFotos_Modelo);
                        Thread obj_Thread_FICHAJESFOTOS = new Thread(obj_ThreadStart_FICHAJESFOTOS);
                        obj_Thread_FICHAJESFOTOS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo[1] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_DispositivosModelo_Modelo()
        {
            try
            {
                KRSS_DispositivosModelo_Datos obj_KRSS_DispositivosModelo_Datos = new KRSS_DispositivosModelo_Datos();
                g_mdl_KRSS_Fichajes.KRSS_DispositivosModelo = obj_KRSS_DispositivosModelo_Datos.Obtener_Modelo_Por_Id(g_mdl_KRSS_Fichajes.idDispositivoModelo, g_mdl_KRSS_Fichajes.codigoCliente);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }

        private void Obtener_FichajesFotos_Modelo()
        {
            try
            {
                KRSS_FichajesFotos_Datos obj_KRSS_FichajesFotos_Datos = new KRSS_FichajesFotos_Datos();
                g_mdl_KRSS_Fichajes.KRSS_FichajesFotos = obj_KRSS_FichajesFotos_Datos.Obtener_ModeloListado_Por_Fichaje(g_mdl_KRSS_Fichajes.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[1] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        #region Modelo Listado
        private List<KRSS_Fichajes> g_lst_KRSS_Fichajes = null;

        public List<KRSS_Fichajes> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRSS_Fichajes),
                                                                                           nameof(KRSS_Fichajes.id),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_Ids);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                            nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente and " +
                                            str_Filtros_IDS;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros,
                                                     false);

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRSS_Fichajes;
        }

        public List<KRSS_Fichajes> Obtener_ModeloListado_Por_EmpleadosFechaEmpresa(List<long> _lst_IdEmpleados, DateTime dtt_Fecha_Inicio, DateTime dtt_Fecha_Fin, long _lng_idEmpresa)
        {
            try
            {

                if (_lst_IdEmpleados != null && _lst_IdEmpleados.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRSS_Fichajes),
                                                                                           nameof(KRSS_Fichajes.idEmpleado),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_IdEmpleados);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                            nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa and " +
                                            nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente and " +
                                            nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + ">=@Fecha_Desde and " +
                                            nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + "<=@Fecha_Hasta and " +
                                            str_Filtros_IDS; 


                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresa));
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    lst_Parametros.Add(new SqlParameter("@Fecha_Desde", dtt_Fecha_Inicio));
                    lst_Parametros.Add(new SqlParameter("@Fecha_Hasta", dtt_Fecha_Fin));

                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros,
                                                     true);

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadosFechaEmpresa), true);
            }

            return g_lst_KRSS_Fichajes;
        }

        public List<KRSS_Fichajes> Obtener_ModeloListado_Por_EmpleadoFechaEmpresa(long _lng_IdEmpleado, DateTime _dtt_Fecha_Desde, DateTime _dtt_Fecha_Hasta, long _lng_idEmpresa)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();


                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        (_lng_IdEmpleado > -1 ? nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpleado) + "=@idEmpleado and " : " " )  +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + ">@Fecha_Desde and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + "<@Fecha_Hasta ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpleado", _lng_IdEmpleado));
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresa));
                lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                lst_Parametros.Add(new SqlParameter("@Fecha_Desde", _dtt_Fecha_Desde));
                lst_Parametros.Add(new SqlParameter("@Fecha_Hasta", _dtt_Fecha_Hasta));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 false);

                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadoFechaEmpresa), true);
            }

            return g_lst_KRSS_Fichajes;
        }

        public List<KRSS_Fichajes> Obtener_ModeloListado_Por_CodigoClienteEmpleadoFechaEmpresa(long _lng_CodigoCliente,long _lng_IdEmpleado, DateTime _dtt_Fecha_Desde, DateTime _dtt_Fecha_Hasta, long _lng_idEmpresa)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + ">=@Fecha_Desde and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.fechaHora) + "<=@Fecha_Hasta and " +
                                        nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.anulado) + " is null " +
                                    " ORDER BY " +
                                         nameof(KRSS_Fichajes) + "." + nameof(KRSS_Fichajes.id) + " ASC ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpleado", _lng_IdEmpleado));
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresa));
                lst_Parametros.Add(new SqlParameter("@codigoCliente", _lng_CodigoCliente));
                lst_Parametros.Add(new SqlParameter("@Fecha_Desde", _dtt_Fecha_Desde));
                lst_Parametros.Add(new SqlParameter("@Fecha_Hasta", _dtt_Fecha_Hasta));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 true);


            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Obtener_ModeloListado_Por_CodigoClienteEmpleadoFechaEmpresa), true);
            }

            return g_lst_KRSS_Fichajes;
        }


        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<KRSS_DispositivosModelo> g_lst_KRSS_DispositivosModelo = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_DispositivoModelo)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_KRSS_Fichajes = obj_KairosProEntities.Database.SqlQuery<KRSS_Fichajes>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_KRSS_Fichajes != null && g_lst_KRSS_Fichajes.Count > 0)
                {
                    
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_DispositivoModelo)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //KRSS_DispositivosModelo #############################################
                        if (_bol_Cargar_DispositivoModelo)
                        {
                            ThreadStart obj_ThreadStart_DISPOSITIVOMODELO = new ThreadStart(Obtener_DispositivoModelo_Modelo_Listado);
                            Thread obj_Thread_DISPOSITIVOMODELO = new Thread(obj_ThreadStart_DISPOSITIVOMODELO);
                            obj_Thread_DISPOSITIVOMODELO.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (KRSS_Fichajes mdl_KRSS_Fichajes in g_lst_KRSS_Fichajes)
                        {
                            //KRSS_DispositivosModelo #############################################
                            if (_bol_Cargar_DispositivoModelo &&
                                g_lst_KRSS_DispositivosModelo != null &&
                                g_lst_KRSS_DispositivosModelo.Count > 0)
                            {
                                mdl_KRSS_Fichajes.KRSS_DispositivosModelo = g_lst_KRSS_DispositivosModelo.Where(m => m.id == mdl_KRSS_Fichajes.idDispositivoModelo).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                    
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }
        #region Tablas Relacionadas
        private void Obtener_DispositivoModelo_Modelo_Listado()
        {
            try
            {
                KRSS_DispositivosModelo_Datos obj_KRSS_DispositivosModelo_Datos = new KRSS_DispositivosModelo_Datos();
                g_lst_KRSS_DispositivosModelo = obj_KRSS_DispositivosModelo_Datos.Obtener_ModeloListado_Por_Ids(g_lst_KRSS_Fichajes.Select(m => m.idDispositivoModelo).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRSS_Fichajes.id) + " , " +
                     nameof(KRSS_Fichajes.idEmpleado) + " , " +
                     nameof(KRSS_Fichajes.codigoCliente) + " , " +
                     nameof(KRSS_Fichajes.fechaHora) + " , " +
                     nameof(KRSS_Fichajes.observaciones) + " , " +
                     nameof(KRSS_Fichajes.gps_Posicion_Latitud) + " , " +
                     nameof(KRSS_Fichajes.gps_Posicion_Longitud) + " , " +
                     nameof(KRSS_Fichajes.gps_FechaHora) + " , " +
                     nameof(KRSS_Fichajes.gps_Proveedor) + " , " +
                     nameof(KRSS_Fichajes.gps_Altitud) + " , " +
                     nameof(KRSS_Fichajes.idTerminal) + " , " +
                     nameof(KRSS_Fichajes.idDispositivoModelo) + " , " +
                     nameof(KRSS_Fichajes.modificado) + " , " +
                     nameof(KRSS_Fichajes.anulado) + " , " +
                     nameof(KRSS_Fichajes.validado) + " , " +
                     nameof(KRSS_Fichajes.tipoDispositivo) + " , " +
                     nameof(KRSS_Fichajes.entradaSalida) + " , " +
                     nameof(KRSS_Fichajes.idEmpresa) + 
                " FROM " + nameof(KRSS_Fichajes);
        }
        #endregion

        #region Grabar, Anular Fichaje, DesAnularFichaje
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRSS_Fichajes mdl_KRSS_Fichajes_AGrabar = (KRSS_Fichajes)_mdl_obj;
                KRSS_Fichajes mdl_KRSS_Fichajes_DatosViejos = new KRSS_Fichajes();

                KRSS_Fichajes mdl_KRSS_Fichajes_Final = Obtener_Modelo_Por_Id(mdl_KRSS_Fichajes_AGrabar.id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO,false,false);

                if (mdl_KRSS_Fichajes_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRSS_Fichajes_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Datos viejos para la trazabilidar
                    Funciones.CopiarPropiedadesObjetos(mdl_KRSS_Fichajes_Final, mdl_KRSS_Fichajes_DatosViejos, false, false);

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRSS_Fichajes_AGrabar, mdl_KRSS_Fichajes_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRSS_Fichajes) +
                                            " SET " +
                                                nameof(KRSS_Fichajes.idEmpleado) + "=@idEmpleado," +
                                                nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRSS_Fichajes.fechaHora) + "=@fechaHora," +
                                                nameof(KRSS_Fichajes.observaciones) + "=@observaciones," +
                                                nameof(KRSS_Fichajes.gps_Posicion_Latitud) + "=@gps_Posicion_Latitud," +
                                                nameof(KRSS_Fichajes.gps_Posicion_Longitud) + "=@gps_Posicion_Longitud," +
                                                nameof(KRSS_Fichajes.gps_FechaHora) + "=@gps_FechaHora," +
                                                nameof(KRSS_Fichajes.gps_Proveedor) + "=@gps_Proveedor," +
                                                nameof(KRSS_Fichajes.gps_Altitud) + "=@gps_Altitud," +
                                                nameof(KRSS_Fichajes.idTerminal) + "=@idTerminal," +
                                                nameof(KRSS_Fichajes.idDispositivoModelo) + "=@idDispositivoModelo," +
                                                nameof(KRSS_Fichajes.modificado) + "=@modificado," +
                                                nameof(KRSS_Fichajes.anulado) + "=@anulado," +
                                                nameof(KRSS_Fichajes.validado) + "=@validado," +
                                                nameof(KRSS_Fichajes.tipoDispositivo) + "=@tipoDispositivo," +
                                                nameof(KRSS_Fichajes.entradaSalida) + "=@entradaSalida," +
                                                nameof(KRSS_Fichajes.idEmpresa) + "=@idEmpresa " +
                                            " WHERE " +
                                                nameof(KRSS_Fichajes.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idEmpleado",  mdl_KRSS_Fichajes_Final.idEmpleado),
                        new SqlParameter("@codigoCliente",  mdl_KRSS_Fichajes_Final.codigoCliente),
                        new SqlParameter("@fechaHora",  mdl_KRSS_Fichajes_Final.fechaHora),
                        mdl_KRSS_Fichajes_Final.observaciones != null
                            ?   new SqlParameter("@observaciones", mdl_KRSS_Fichajes_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                        new SqlParameter("@gps_Posicion_Latitud",  mdl_KRSS_Fichajes_Final.gps_Posicion_Latitud),
                        new SqlParameter("@gps_Posicion_Longitud",  mdl_KRSS_Fichajes_Final.gps_Posicion_Longitud),
                        mdl_KRSS_Fichajes_Final.gps_FechaHora != null
                            ?   new SqlParameter("@gps_FechaHora", mdl_KRSS_Fichajes_Final.gps_FechaHora.Value)
                            :   new SqlParameter("@gps_FechaHora",  DBNull.Value),
                        new SqlParameter("@gps_Proveedor",  mdl_KRSS_Fichajes_Final.gps_Proveedor),
                        mdl_KRSS_Fichajes_Final.gps_Altitud != null
                            ?   new SqlParameter("@gps_Altitud", mdl_KRSS_Fichajes_Final.gps_Altitud)
                            :   new SqlParameter("@gps_Altitud",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.idTerminal != null
                            ?   new SqlParameter("@idTerminal", mdl_KRSS_Fichajes_Final.idTerminal)
                            :   new SqlParameter("@idTerminal",  DBNull.Value),
                        new SqlParameter("@idDispositivoModelo",  mdl_KRSS_Fichajes_Final.idDispositivoModelo),
                        mdl_KRSS_Fichajes_Final.modificado != null
                            ?   new SqlParameter("@modificado", mdl_KRSS_Fichajes_Final.modificado.Value)
                            :   new SqlParameter("@modificado",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.anulado != null
                            ?   new SqlParameter("@anulado", mdl_KRSS_Fichajes_Final.anulado.Value)
                            :   new SqlParameter("@anulado",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.validado != null
                            ?   new SqlParameter("@validado", mdl_KRSS_Fichajes_Final.validado.Value)
                            :   new SqlParameter("@validado",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.tipoDispositivo != null
                            ?   new SqlParameter("@tipoDispositivo", mdl_KRSS_Fichajes_Final.tipoDispositivo.Value)
                            :   new SqlParameter("@tipoDispositivo",  DBNull.Value),
                        new SqlParameter("@entradaSalida",  mdl_KRSS_Fichajes_Final.entradaSalida),
                       mdl_KRSS_Fichajes_Final.idEmpresa != null
                            ?   new SqlParameter("@idEmpresa", mdl_KRSS_Fichajes_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value),
                        new SqlParameter("@id",  mdl_KRSS_Fichajes_Final.id),
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRSS_Fichajes_Final.id;
                }
                else
                {
                    mdl_KRSS_Fichajes_Final = new KRSS_Fichajes();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRSS_Fichajes_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRSS_Fichajes_AGrabar, mdl_KRSS_Fichajes_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRSS_Fichajes) +
                                                " (" +
                                                         nameof(KRSS_Fichajes.idEmpleado) + "," +
                                                         nameof(KRSS_Fichajes.codigoCliente) + "," +
                                                         nameof(KRSS_Fichajes.fechaHora) + "," +
                                                         nameof(KRSS_Fichajes.observaciones) + "," +
                                                         nameof(KRSS_Fichajes.gps_Posicion_Latitud) + "," +
                                                         nameof(KRSS_Fichajes.gps_Posicion_Longitud) + "," +
                                                         nameof(KRSS_Fichajes.gps_FechaHora) + "," +
                                                         nameof(KRSS_Fichajes.gps_Proveedor) + "," +
                                                         nameof(KRSS_Fichajes.gps_Altitud) + "," +
                                                         nameof(KRSS_Fichajes.idTerminal) + "," +
                                                         nameof(KRSS_Fichajes.idDispositivoModelo) + "," +
                                                         nameof(KRSS_Fichajes.modificado) + "," +
                                                         nameof(KRSS_Fichajes.anulado) + "," +
                                                         nameof(KRSS_Fichajes.validado) + "," +
                                                         nameof(KRSS_Fichajes.tipoDispositivo) + "," +
                                                         nameof(KRSS_Fichajes.entradaSalida) + "," +
                                                         nameof(KRSS_Fichajes.idEmpresa) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(KRSS_Fichajes.id) +
                                                " VALUES " +
                                                " ( " +
                                                     "@idEmpleado," +
                                                     "@codigoCliente," +
                                                     "@fechaHora," +
                                                     "@observaciones," +
                                                     "@gps_Posicion_Latitud," +
                                                     "@gps_Posicion_Longitud," +
                                                     "@gps_FechaHora," +
                                                     "@gps_Proveedor," +
                                                     "@gps_Altitud," +
                                                     "@idTerminal," +
                                                     "@idDispositivoModelo," +
                                                     "@modificado," +
                                                     "@anulado," +
                                                     "@validado," +
                                                     "@tipoDispositivo," +
                                                     "@entradaSalida," +
                                                     "@idEmpresa" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idEmpleado",  mdl_KRSS_Fichajes_Final.idEmpleado),
                        new SqlParameter("@codigoCliente",  mdl_KRSS_Fichajes_Final.codigoCliente),
                        new SqlParameter("@fechaHora",  mdl_KRSS_Fichajes_Final.fechaHora),
                        mdl_KRSS_Fichajes_Final.observaciones != null
                            ?   new SqlParameter("@observaciones", mdl_KRSS_Fichajes_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                        new SqlParameter("@gps_Posicion_Latitud",  mdl_KRSS_Fichajes_Final.gps_Posicion_Latitud),
                        new SqlParameter("@gps_Posicion_Longitud",  mdl_KRSS_Fichajes_Final.gps_Posicion_Longitud),
                        mdl_KRSS_Fichajes_Final.gps_FechaHora != null
                            ?   new SqlParameter("@gps_FechaHora", mdl_KRSS_Fichajes_Final.gps_FechaHora.Value)
                            :   new SqlParameter("@gps_FechaHora",  DBNull.Value),
                        new SqlParameter("@gps_Proveedor",  mdl_KRSS_Fichajes_Final.gps_Proveedor),
                        mdl_KRSS_Fichajes_Final.gps_Altitud != null
                            ?   new SqlParameter("@gps_Altitud", mdl_KRSS_Fichajes_Final.gps_Altitud)
                            :   new SqlParameter("@gps_Altitud",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.idTerminal != null
                            ?   new SqlParameter("@idTerminal", mdl_KRSS_Fichajes_Final.idTerminal)
                            :   new SqlParameter("@idTerminal",  DBNull.Value),
                        new SqlParameter("@idDispositivoModelo",  mdl_KRSS_Fichajes_Final.idDispositivoModelo),
                        mdl_KRSS_Fichajes_Final.modificado != null
                            ?   new SqlParameter("@modificado", mdl_KRSS_Fichajes_Final.modificado.Value)
                            :   new SqlParameter("@modificado",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.anulado != null
                            ?   new SqlParameter("@anulado", mdl_KRSS_Fichajes_Final.anulado.Value)
                            :   new SqlParameter("@anulado",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.validado != null
                            ?   new SqlParameter("@validado", mdl_KRSS_Fichajes_Final.validado.Value)
                            :   new SqlParameter("@validado",  DBNull.Value),
                        mdl_KRSS_Fichajes_Final.tipoDispositivo != null
                            ?   new SqlParameter("@tipoDispositivo", mdl_KRSS_Fichajes_Final.tipoDispositivo.Value)
                            :   new SqlParameter("@tipoDispositivo",  DBNull.Value),
                        new SqlParameter("@entradaSalida",  mdl_KRSS_Fichajes_Final.entradaSalida),
                       mdl_KRSS_Fichajes_Final.idEmpresa != null
                            ?   new SqlParameter("@idEmpresa", mdl_KRSS_Fichajes_Final.idEmpresa.Value)
                            :   new SqlParameter("@idEmpresa",  DBNull.Value)
                        };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();

                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRSS_Fichajes), mdl_KRSS_Fichajes_DatosViejos, mdl_KRSS_Fichajes_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Anular_Fichaje(long _lng_id, DateTime _dtt_Hoy)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(KRSS_Fichajes) +
                                            " SET " +
                                                nameof(KRSS_Fichajes.anulado) + "=@fechaanulado, " +
                                                nameof(KRSS_Fichajes.modificado) + "=@fechamodificado " +
                                         " WHERE " +
                                                nameof(KRSS_Fichajes.id) + "=@id and " +
                                                nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente ";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@fechaanulado",  _dtt_Hoy),
                    new SqlParameter("@fechamodificado",  _dtt_Hoy),
                    new SqlParameter("@id", _lng_id),
                    new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };
                #endregion

                //Update
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                //Devolver tambien el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Anular_Fichaje), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo DesAnular_Fichaje(long _lng_id,DateTime _dtt_Hoy)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(KRSS_Fichajes) +
                                            " SET " +
                                                nameof(KRSS_Fichajes.anulado) + "=@fechaanulado, " +
                                                nameof(KRSS_Fichajes.modificado) + "=@fechamodificado " +
                                         " WHERE " +
                                                nameof(KRSS_Fichajes.id) + "=@id and " +
                                                nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente ";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@fechaanulado",  DBNull.Value),
                    new SqlParameter("@fechamodificado",  _dtt_Hoy),
                    new SqlParameter("@id", _lng_id),
                    new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };
                #endregion

                //Update
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                //Devolver tambien el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(DesAnular_Fichaje), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public void Actualizar_ParaVerificacionFichajes(long _lng_idFichaje, int _int_Validado, long _lng_CodigoCliente)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(KRSS_Fichajes) +
                                            " SET " +
                                                nameof(KRSS_Fichajes.validado) + "=@validado " +
                                         " WHERE " +
                                                nameof(KRSS_Fichajes.id) + "=@id and " +
                                                nameof(KRSS_Fichajes.codigoCliente) + "=@codigoCliente ";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@validado",  _int_Validado),
                    new SqlParameter("@id", _lng_idFichaje),
                    new SqlParameter("@codigoCliente", _lng_CodigoCliente)
                };
                #endregion

                //Update
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Actualizar_ParaVerificacionFichajes), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        //Esta funcion la utiliza el servicio de windows para insertar un fichaje automaticamente
        public void Insertar(KRSS_Fichajes _mdl_KRSS_Fichajes)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_Insert = " INSERT INTO " + nameof(KRSS_Fichajes) +
                                               " (" +
                                                        nameof(KRSS_Fichajes.idEmpleado) + "," +
                                                        nameof(KRSS_Fichajes.codigoCliente) + "," +
                                                        nameof(KRSS_Fichajes.fechaHora) + "," +
                                                        nameof(KRSS_Fichajes.observaciones) + "," +
                                                        nameof(KRSS_Fichajes.gps_Posicion_Latitud) + "," +
                                                        nameof(KRSS_Fichajes.gps_Posicion_Longitud) + "," +
                                                        nameof(KRSS_Fichajes.gps_FechaHora) + "," +
                                                        nameof(KRSS_Fichajes.gps_Proveedor) + "," +
                                                        nameof(KRSS_Fichajes.gps_Altitud) + "," +
                                                        nameof(KRSS_Fichajes.idTerminal) + "," +
                                                        nameof(KRSS_Fichajes.idDispositivoModelo) + "," +
                                                        nameof(KRSS_Fichajes.modificado) + "," +
                                                        nameof(KRSS_Fichajes.anulado) + "," +
                                                        nameof(KRSS_Fichajes.validado) + "," +
                                                        nameof(KRSS_Fichajes.tipoDispositivo) + "," +
                                                        nameof(KRSS_Fichajes.entradaSalida) + "," +
                                                        nameof(KRSS_Fichajes.idEmpresa) + 
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(KRSS_Fichajes.id) +
                                               " VALUES " +
                                               " ( " +
                                                    "@idEmpleado," +
                                                    "@codigoCliente," +
                                                    "@fechaHora," +
                                                    "@observaciones," +
                                                    "@gps_Posicion_Latitud," +
                                                    "@gps_Posicion_Longitud," +
                                                    "@gps_FechaHora," +
                                                    "@gps_Proveedor," +
                                                    "@gps_Altitud," +
                                                    "@idTerminal," +
                                                    "@idDispositivoModelo," +
                                                    "@modificado," +
                                                    "@anulado," +
                                                    "@validado," +
                                                    "@tipoDispositivo," +
                                                    "@entradaSalida," +
                                                    "@idEmpresa" +
                                               " ) ";
                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@idEmpleado",  _mdl_KRSS_Fichajes.idEmpleado),
                    new SqlParameter("@codigoCliente",  _mdl_KRSS_Fichajes.codigoCliente),
                    new SqlParameter("@fechaHora",  _mdl_KRSS_Fichajes.fechaHora),
                    _mdl_KRSS_Fichajes.observaciones != null
                        ?   new SqlParameter("@observaciones", _mdl_KRSS_Fichajes.observaciones)
                        :   new SqlParameter("@observaciones",  DBNull.Value),
                    new SqlParameter("@gps_Posicion_Latitud",  _mdl_KRSS_Fichajes.gps_Posicion_Latitud),
                    new SqlParameter("@gps_Posicion_Longitud",  _mdl_KRSS_Fichajes.gps_Posicion_Longitud),
                    _mdl_KRSS_Fichajes.gps_FechaHora != null
                        ?   new SqlParameter("@gps_FechaHora", _mdl_KRSS_Fichajes.gps_FechaHora.Value)
                        :   new SqlParameter("@gps_FechaHora",  DBNull.Value),
                    new SqlParameter("@gps_Proveedor",  _mdl_KRSS_Fichajes.gps_Proveedor),
                    _mdl_KRSS_Fichajes.gps_Altitud != null
                        ?   new SqlParameter("@gps_Altitud", _mdl_KRSS_Fichajes.gps_Altitud)
                        :   new SqlParameter("@gps_Altitud",  DBNull.Value),
                    _mdl_KRSS_Fichajes.idTerminal != null
                        ?   new SqlParameter("@idTerminal", _mdl_KRSS_Fichajes.idTerminal)
                        :   new SqlParameter("@idTerminal",  DBNull.Value),
                    new SqlParameter("@idDispositivoModelo",  _mdl_KRSS_Fichajes.idDispositivoModelo),
                    _mdl_KRSS_Fichajes.modificado != null
                        ?   new SqlParameter("@modificado", _mdl_KRSS_Fichajes.modificado.Value)
                        :   new SqlParameter("@modificado",  DBNull.Value),
                    _mdl_KRSS_Fichajes.anulado != null
                        ?   new SqlParameter("@anulado", _mdl_KRSS_Fichajes.anulado.Value)
                        :   new SqlParameter("@anulado",  DBNull.Value),
                    _mdl_KRSS_Fichajes.validado != null
                        ?   new SqlParameter("@validado", _mdl_KRSS_Fichajes.validado.Value)
                        :   new SqlParameter("@validado",  DBNull.Value),
                    _mdl_KRSS_Fichajes.tipoDispositivo != null
                        ?   new SqlParameter("@tipoDispositivo", _mdl_KRSS_Fichajes.tipoDispositivo.Value)
                        :   new SqlParameter("@tipoDispositivo",  DBNull.Value),
                    new SqlParameter("@entradaSalida",  _mdl_KRSS_Fichajes.entradaSalida),
                   _mdl_KRSS_Fichajes.idEmpresa != null
                        ?   new SqlParameter("@idEmpresa", _mdl_KRSS_Fichajes.idEmpresa.Value)
                        :   new SqlParameter("@idEmpresa",  DBNull.Value)
                };

                //Id de la tabla
                obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRSS_Fichajes_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
